<?php defined('SYSPATH') or die('No direct script access.');

class Model_Kohana_Account extends Model
{
    public function setHashKey($key)
    {
        $key = Database::instance()->escape($key);
        $sql = "SELECT `SetSettings`('HashKey', '', $key) AS `Key`;";
        $res = DB::query(Database::SELECT, $sql)->execute();
        return $res->get('Key');
    }

    public function getHashKey()
    {
        $sql = "CALL `GetSettings`('HashKey');";
        $key = DB::query(Database::SELECT, $sql)->execute();
        return $key->get('ValS');
    }

    public function getMaintenanceInfo()
    {
        $sql = "CALL `GetSettings`('maintenance_active');";
        $key = DB::query(Database::SELECT, $sql)->execute();
        $result['active'] = ($key->get('Val') == 1);
        $sql = "CALL `GetSettings`('maintenance_return');";
        $key = DB::query(Database::SELECT, $sql)->execute();
        $result['return'] = $key->get('ValS');
        return $result;
    }

    public function checkAuth($login, $password) {
        $db = Database::instance();
        $login = $db->escape($login);
        $password = $db->escape($password);
        $sql = "SELECT `SignIn`($login, $password) AS `ID`;";
        $res = DB::query(Database::SELECT, $sql)->execute();
        return $res->get('ID');
    }


    public function ChangeTeacherInfo($id, $lastName, $firstName, $secondName, $degreeID, $departmentID)

    {
        $db = Database::instance();
        $lastName = $db->escape($lastName);
        $secondName = $db->escape($secondName);
        $firstName = $db->escape($firstName);
        $sql = "SELECT `ChangeTeacherInfo`('$id', $lastName, $firstName, $secondName, '$degreeID', '$departmentID') AS `UserID`;";
        $key = DB::query(Database::SELECT, $sql)->execute();
        return $key->get('UserID');
    }


    public function createTeacher($lastName, $firstName, $secondName, $degreeID, $departmentID, $activationCode)
    {
        $db = Database::instance();
        $lastName = $db->escape($lastName);
        $secondName = $db->escape($secondName);
        $firstName = $db->escape($firstName);
        $activationCode = $db->escape($activationCode);
        $sql = "SELECT `CreateTeacher`($lastName, $firstName, $secondName, '$degreeID', '$departmentID', $activationCode) AS `UserID`;";
        $key = DB::query(Database::SELECT, $sql)->execute();
        return $key->get('UserID');
    }


    public function createTeacherByDepName($lastName, $firstName, $secondName, $departmentID, $facultyID, $activationCode)
    {
        if ($departmentID == '') {
            return -1;
        }

        $db = Database::instance();
        $lastName = $db->escape($lastName);
        $secondName = $db->escape($secondName);
        $firstName = $db->escape($firstName);
        $activationCode = $db->escape($activationCode);
        $departmentID = $db->escape($departmentID);
        $sql = "SELECT `CreateTeacherByDepName`($lastName, $firstName, $secondName, $departmentID, '$facultyID', $activationCode) AS `UserID`;";
        $key = DB::query(Database::SELECT, $sql)->execute();
        return $key->get('UserID');
    }

    public function createStudent($lastName, $firstName, $secondName, $grade, $groupNum, $facultyID, $activationCode)
    {
        $db = Database::instance();
        $lastName = $db->escape($lastName);
        $secondName = $db->escape($secondName);
        $firstName = $db->escape($firstName);
        $activationCode = $db->escape($activationCode);
        $sql = "SELECT `CreateStudent`($lastName, $firstName, $secondName, '$grade', '$groupNum', '$facultyID', $activationCode) AS `UserID`;";
        $key = DB::query(Database::SELECT, $sql)->execute();
        return $key->get('UserID');
    }

    public function createStudentEx($lastName, $firstName, $secondName, $gradeNum, $groupNum, $degree, $specialization, $facultyID, $activationCode)
    {
        $db = Database::instance();
        $lastName = $db->escape($lastName);
        $secondName = $db->escape($secondName);
        $firstName = $db->escape($firstName);
        $activationCode = $db->escape($activationCode);
        $degree = $db->escape($degree);
        $specialization = $db->escape($specialization);
        $sql = "SELECT `CreateStudentEx`($lastName, $firstName, $secondName, '$gradeNum', '$groupNum', $degree, $specialization, '$facultyID', $activationCode) AS `UserID`;";
        $key = DB::query(Database::SELECT, $sql)->execute();
        return $key->get('UserID');
    }

    public function createSubject($name, $abbr, $facultyID)
    {
        $db = Database::instance();
        $name = $db->escape($name);
        $abbr = $db->escape($abbr);
        $sql = "SELECT `CreateSubject`('$facultyID', $name, $abbr) AS `Num`;";
        $response = DB::query(Database::SELECT, $sql)->execute();
        return $response->get('Num');
    }

    public static function getPersonalInfo($id, $semesterID = null) {
        $semesterID = $semesterID ? $semesterID : User::instance()->SemesterID;
        $sql = "CALL `GetPersonalInfo`('$id', $semesterID);";
        $query = DB::query(Database::SELECT, $sql)->execute();
        return $query[0];
    }

    public static function GetAccountInfo($id)
    {
        $sql = "CALL GetAccountInfo('$id');";
        $query = DB::query(Database::SELECT, $sql)->execute();
        return $query[0];
    }

    public function changeMail($id, $mail)
    {
        $mail = Database::instance()->escape($mail);
        $sql = "SELECT `ChangeAccountData`('$id', $mail, 'email') AS Num;";
        $query = DB::query(Database::SELECT, $sql)->execute();
        return $query->get('Num');
    }

    public function changeLogin($id, $login)
    {
        $login = Database::instance()->escape($login);
        $sql = "SELECT `ChangeAccountData`('$id', $login, 'login') AS Num;";
        $query = DB::query(Database::SELECT, $sql)->execute();
        return $query->get('Num');
    }

    public function changePassword($id, $password)
    {
        $password = Database::instance()->escape($password);
        $sql = "SELECT `ChangeAccountData`('$id', $password, 'password') AS Num;";
        $query = DB::query(Database::SELECT, $sql)->execute();
        return $query->get('Num');
    }

    public function getAccNumByLogin($login)
    {
        $login = Database::instance()->escape($login);
        $sql = "SELECT `CheckAccountExistence`($login, 'login') AS Num;";
        $res = DB::query(Database::SELECT, $sql)->execute();
        return $res->get('Num');
    }

    public function getAccNumByMail($email)
    {
        $email = Database::instance()->escape($email);
        $sql = "SELECT `CheckAccountExistence`($email, 'email') AS Num;";
        $res = DB::query(Database::SELECT, $sql)->execute();
        return $res->get('Num');
    }

    public function isActivationCodeValid($code)
    {
        $code = Database::instance()->escape($code);
        $sql = "SELECT `CheckAccountExistence`($code, 'code') AS Num;";
        $res = DB::query(Database::SELECT, $sql)->execute();

        $count = $res[0]['Num'];
        return $count == 1;
    }

    public function createRecoveryToken($email, $token)
    {
        $db = Database::instance();
        $email = $db->escape($email);
        $token = $db->escape($token);
        $sql = "SELECT `CreateRecoveryToken`($email, $token) AS UserName;";
        $res = DB::query(Database::SELECT, $sql)->execute();
        return $res->get('UserName');
    }

    public function getRecoveryInfoByEMail($email)
    {
        $email = Database::instance()->escape($email);
        $sql = "CALL GetRecoveryInfoByEMail($email);";
        $query = DB::query(Database::SELECT, $sql)->execute();
        return $query;
    }

    public function getRecoveryInfoByToken($token)
    {
        $token = Database::instance()->escape($token);
        $sql = "CALL GetRecoveryInfoByToken($token);";
        $query = DB::query(Database::SELECT, $sql)->execute();
        return $query;
    }

    public function useRecoveryToken($token)
    {
        $token = Database::instance()->escape($token);
        $sql = "SELECT `UseRecoveryToken`($token) AS Num;";
        $email = DB::query(Database::SELECT, $sql)->execute();
        return $email->get('Num');
    }

    public function activateAccount($login, $password, $email, $code)
    {
        $db = Database::instance();
        $login = $db->escape($login);
        $password = $db->escape($password);
        $email = $db->escape($email);
        $code = $db->escape($code);
        $sql = "SELECT `ActivateAccount` ($code, $login, $email, $password) AS `Num`; ";
        $res = DB::query(Database::SELECT, $sql)->execute();
        foreach ($res as $value) {
            $id = $value['Num'];
        }
        return $id;
    }

    public function getCurSemesterID() {
        $sql = "CALL `GetSettings`('SemesterID');";
        $res = DB::query(Database::SELECT, $sql)->execute();
        $id = null;
        foreach ($res as $value) {
            $id = $value['Val'];
        }
        return $id;
    }

}